var objTxtbgfixerBrowser = {

	onload: function (ndTarget)
	{
		if (! gPrefService.prefHasUserValue('txtbgfixer.enabled'))
			gPrefService.setBoolPref('txtbgfixer.enabled', true);
		if (! gPrefService.prefHasUserValue('txtbgfixer.invert_colors'))
			gPrefService.setBoolPref('txtbgfixer.invert_colors', false);

		if (! gPrefService.getBoolPref('txtbgfixer.enabled') ||
			! gPrefService.getBoolPref('browser.display.use_document_colors')) return;

		ndDocument = ndTarget.originalTarget;
		ndBody = ndDocument.getElementsByTagName("body")[0]; if (ndBody==null) return;
		bInvertColors = false;

		sTxtcolor = ndBody.getAttribute("text");
		sBgcolor = ndBody.getAttribute("bgcolor");
		if (sBgcolor && !sTxtcolor) {
			if (sBgcolor != "#000000") ndBody.setAttribute("text", "#000000");
		}
		else if (!sBgcolor && sTxtcolor) {
			if (sTxtcolor != "#FFFFFF") ndBody.setAttribute("bgcolor", "#FFFFFF");
		}
		else if (!sBgcolor && !sTxtcolor) {
			if (this.fixElementColors (ndDocument, ndBody, "body", false));
			else if (this.fixElementColors (ndDocument, ndBody, "td", false));
			else if (this.fixElementColors (ndDocument, ndBody, "p", false));
			else if (this.fixElementColors (ndDocument, ndBody, "a", false));
		}
		
		if (ndDocument.getElementsByTagName("form").length > 0) {
			this.fixElementColors (ndDocument, ndBody, "input", true);
			this.fixElementColors (ndDocument, ndBody, "textarea", true);
			this.fixElementColors (ndDocument, ndBody, "select", true);
			this.fixElementColors (ndDocument, ndBody, "option", true);
		}

		if ( ndDocument.vlinkColor == ndDocument.linkColor ) {
			ndDocument.vlinkColor = this.arrayToHex(this.rgbDarken(this.hexToArray(ndDocument.vlinkColor)));
		}

		bgColor = this.getRGBColor(ndDocument,ndBody,"background-color");
		fgColor = this.getRGBColor(ndDocument,ndBody,"color");
		if ((!bgColor && this.areArrayRGBColorsSimilar(fgColor,[0,0,0],50)) ||
			(bgColor && this.areArrayRGBColorsSimilar(bgColor,[255,255,255],150)))
				bInvertColors = true;

		if (ndDocument.styleSheets.length > 0) {
			for (var j=0; j<ndDocument.styleSheets.length; ++j)
			for (var i=0; i<ndDocument.styleSheets[j].cssRules.length; ++i) {
				if (ndDocument.styleSheets[j].cssRules[i].selectorText) {
					if (ndDocument.styleSheets[j].cssRules[i].selectorText.indexOf("a:visited") != -1) {
						sLinkcolor = ndDocument.defaultView.getComputedStyle(ndDocument.links[0],null).getPropertyValue("color");
						if ((sVlinkcolor=ndDocument.styleSheets[j].cssRules[i].style.color) != "") {
							if (sLinkcolor == sVlinkcolor) {
								ndDocument.styleSheets[j].cssRules[i].style.color =
									this.arrayToRGB(this.rgbDarken(this.rgbToArray(sVlinkcolor)));
							}
						}
					}
					if (cssBgcolor = ndDocument.styleSheets[j].cssRules[i].style.backgroundColor) {
						if (this.areArrayRGBColorsSimilar(this.rgbToArray(cssBgcolor),[255,255,255],50))
							bInvertColors = true;
					}
					if (bInvertColors && ndDocument.styleSheets[j].cssRules[i].style.backgroundImage.substr(0,3) == "url") {
						ndDocument.styleSheets[j].cssRules[i].style.backgroundImage = "none";
					}
				}
			}
		}

		if (bInvertColors && gPrefService.getBoolPref('txtbgfixer.invert_colors')) {
			tdNodes = ndDocument.getElementsByTagName("td");
			for (i=0; i<tdNodes.length; ++i)
				if (tdNodes[i].getAttribute("background"))
					tdNodes[i].setAttribute("background","");
			
			function recNodeFix(obj, doc, n) {
				var i,x,c,b;
				if (n.nodeType==Node.ELEMENT_NODE) {
					for ( i=0; x=n.childNodes[i]; ++i )
						recNodeFix(obj, doc, x);

					c = obj.getRGBColor(doc, n, "color");
					b = obj.getRGBColor(doc, n, "background-color");
					n.style.color = obj.rgbInvertToCSS(c);
					if (b) n.style.backgroundColor = obj.rgbInvertToCSS(b);
				}
			}
			recNodeFix(this, ndDocument, ndDocument.documentElement);
		}

	},


	fixElementColors: function (ndDocument, ndBody, tagname, bFixIndividualElement) {
		fixed = false;
		ndElement = ndDocument.getElementsByTagName(tagname);
		for (i = 0; i < ndElement.length; i++) {
			aTxtcolor = this.getRGBColor(ndDocument, ndElement[i], "color");
			aBgcolor = this.getRGBColor(ndDocument, ndElement[i], "background-color");

			if (!aTxtcolor) aTxtcolor = this.hexToArray(gPrefService.getCharPref('browser.display.foreground_color'));
			if (!aBgcolor) aBgcolor = this.hexToArray(gPrefService.getCharPref('browser.display.background_color'));

			if (this.areArrayRGBColorsSimilar(aTxtcolor, aBgcolor, 102)) {
				if (bFixIndividualElement) {
					ndElement[i].setAttribute("style", ndElement[i].getAttribute("style") +
						"; background-color: #FFFFFF; color: #000000;");
					fixed = true;
				}
				else {
					ndBody.setAttribute("text", "#000000");
					ndBody.setAttribute("bgcolor", "#FFFFFF");
					return true;
				}
			}
		}
		return fixed;
	},

	getRGBColor: function (ndDocument, node, prop) {
		rgb = ndDocument.defaultView.getComputedStyle(node,null).getPropertyValue(prop);
		if (/rgb\((\d+),\s(\d+),\s(\d+)\)/.exec(rgb)) {
			r = parseInt(RegExp.$1, 10);
			g = parseInt(RegExp.$2, 10);
			b = parseInt(RegExp.$3, 10);
			return [r,g,b];
		}
	},

	rgbInvertToCSS: function (c) {
		for (i=0; i<3; ++i) {
			c[i] = 255-c[i];
			if (c[i] > 210) c[i] = 210;
		}
		return "rgb("+c[0]+","+c[1]+","+c[2]+")";
	},

	rgbDarken: function (c) {
		for (i=0; i<3; ++i) {
			c[i] -= 51;
			if (c[i] < 0) c[i] = 0;
		}
		return c;
	},

	rgbToArray: function (s) {
		return s.replace("rgb(","").replace(")","").split(",");
	},

	arrayToRGB: function (a) {
		return "rgb("+a[0]+", "+a[1]+", "+a[2]+")";
	},

	areArrayRGBColorsSimilar: function (aRGB1, aRGB2, diff) {
		if (aRGB1 && aRGB2)
			for (j = 0; j < 3; j++)
				if (Math.abs(aRGB1[j] - aRGB2[j]) > diff) return false;
		return true;
	},

	hexToArray: function (s) {
		s = s.substr(1).toUpperCase();
		return [ parseInt(s.substr(0,2),16), parseInt(s.substr(2,2),16), parseInt(s.substr(4,2),16) ];
	},

	arrayToHex: function (c) {
		retval = "#";
		for (i=0; i<3; ++i) {
			if (c[i] <= 16) retval += "0";
			retval += c[i].toString(16);
		}
		return retval;
	},


	toggle: function()
	{
		if (gPrefService.getBoolPref('txtbgfixer.enabled')) {
			gPrefService.setBoolPref('txtbgfixer.enabled', false);
			gPrefService.setBoolPref('browser.display.use_document_colors', false);
			window._content.document.location.reload();
			this.setstatustxt("Txt-Bgcolor Fixer forcing user-defined colors");
		}
		else if (gPrefService.getBoolPref('browser.display.use_document_colors')) {
			gPrefService.setBoolPref('txtbgfixer.enabled', true);
			gPrefService.setBoolPref('browser.display.use_document_colors', true);
			window._content.document.location.reload();
			this.setstatustxt("Txt-Bgcolor Fixer on");
		}
		else {
			gPrefService.setBoolPref('txtbgfixer.enabled', false);
			gPrefService.setBoolPref('browser.display.use_document_colors', true);
			window._content.document.location.reload();
			this.setstatustxt("Txt-Bgcolor Fixer off");
		}
	},

	setstatustxt: function (msg)
	{
		document.getElementById("statusbar-display").label = msg;
	}
}

function txtbgfixerLoadWindow (e) {
	objTxtbgfixerBrowser.onload (e);
}

window.addEventListener ("DOMContentLoaded", txtbgfixerLoadWindow, null);
